//////////////////////////////////////////////////////////////////////
// JetSQL - MS Jet SQL script interpreter (c) TECHSYS HW a SW s.r.o.
//////////////////////////////////////////////////////////////////////
// Modul:  Preparser.cpp
// Author: Pavel Klocek
// Desc:   Implementation of class CPreparser
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Preparser.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

char CPreparser::m_command[MAXCMDLN];

CPreparser::CPreparser()
{
	m_state = start;
	m_pos = 0;
}

CPreparser::~CPreparser()
{

}

bool CPreparser::put(char ch)
{
	switch(m_state)
	{
	case slash:
		if(ch=='*') {m_state = comment;	return false;}
		append('/');
		m_state = normal;
		return put(ch);
	case whitespace:
		if(isspace(ch)) return false;
		m_state = normal;
		return put(ch);
	case start:
		m_state = normal;
	case normal:
		if(ch=='/') {m_state = slash; return false;}
		if(isspace(ch))
		{
			append(' ');
			m_state = whitespace;
			return false;
		}
		if(ch==';') 
		{
			//end of command
			append(0);
			m_state = start;
			m_pos = 0;
			return true;
		}
		append(ch);
		return false;
	case star:
		if(ch!='*') m_state = comment;
		if(ch=='/') m_state = normal;
		return false;
	case comment:
		if(ch=='*') m_state = star;
		return false;
	}
	return false;
}

char* CPreparser::GetCommand()
{
	return (char*)&m_command;
}

void CPreparser::append(char ch)
{
	if(m_pos==MAXCMDLN-1) throw CString("Too long command");
	m_command[m_pos++]=ch;
}
