//////////////////////////////////////////////////////////////////////
// JetSQL - MS Jet SQL script interpreter (c) TECHSYS HW a SW s.r.o.
//////////////////////////////////////////////////////////////////////
// Modul:  Preparser.h
// Author: Pavel Klocek
// Desc:   Definition of class CPreparser
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PREPARSER_H__7C774032_29A2_11D3_B7A7_000000000000__INCLUDED_)
#define AFX_PREPARSER_H__7C774032_29A2_11D3_B7A7_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define MAXCMDLN 5000	//maximal length of SQL command

//////////////////////////////////////////////////////////////////////
// class CPreparser
//--------------------------------------------------------------------
// Completes SQL commands from readed characters, bypasses
// comments, shrinks whitespace characters.
//////////////////////////////////////////////////////////////////////
class CPreparser  
{
public:
	CPreparser();
	virtual ~CPreparser();

	//appends character to the command,
	//returns true, if the command is comleted
	bool put(char ch);
	//returns the command
	char* GetCommand();

	//state of the class
	enum{start,normal,comment,whitespace,slash,star} m_state;

protected:
	//current position in m_command (for next character)
	int m_pos;
	//buffer for current command
	static char m_command[MAXCMDLN];

	//appends character to the m_command
	void append(char ch);

	
};

#endif // !defined(AFX_PREPARSER_H__7C774032_29A2_11D3_B7A7_000000000000__INCLUDED_)
